#!/bin/bash
# Version: 0.1.0
# Copyright (c) 2023:
#   Darren 'Tadgy' Austin <darren (at) afterdark.org.uk>
# Licensed under the terms of the GNU General Public License version 3.
#
# Wrapper around /opt/bin/mirror to keep a log of the mirroring session, and email it.

# Configuration.
COMMAND="/opt/bin/mirror"
LOGSDIR="/var/log/duplication/mirroring/$(printf "%(%Y/%m)T")"
LOGFILE="$(printf "%(%Y%m%d-%H%M%S)T")-$$"
MIN_LOGFILE_SIZE="550"

# Only allow one copy of the script to run at any time.
# shellcheck disable=SC2154
if [[ "$FLOCK" != "$0" ]]; then
  # shellcheck disable=SC2093
  exec env FLOCK="$0" flock -E 10 -e -n "$0" "$0" "$@"
  ERR="$?"
  if (( ERR == 10 )); then
    # File is locked, exit now.
    exit 0
  elif (( ERR > 0 )); then
    printf "%s: %s\\n" "${0##*/}" "flock execution error" >&2
    exit 1
  fi
fi

# Source the mail configuration.
source /etc/mail.conf "backups" 2>/dev/null || {
  printf "%s: %s\\n" "${0##*/}" "Failed to source /etc/mail.conf" >&2
  exit 1
}

# Make sure the logs directory exists.
mkdir -p "$LOGSDIR" 2>/dev/null || {
  printf "%s: %s\\n" "${0##*/}" "Failed to create logs directory" >&2
  exit 1
}

# Make sure the command to do the work is runnable.
[[ ! -x "$COMMAND" ]] && {
  printf "%s: '%s' %s\\n" "${0##*/}" "$COMMAND" "is not executable" >&2
  exit 1
}

# Do the mirroring work.
"$COMMAND" "$@" >"$LOGSDIR/$LOGFILE" 2>&1
ERR="$?"

# Tell the sysadmin what went on.
if (( "$ERR" == 0 )); then
  # Only email a mirroring report if it's not a Slackware tree only hourly run.
  # The size of the log file determines if it gets emailed.
  (( $(stat --printf="%s" "$LOGSDIR/$LOGFILE") > MIN_LOGFILE_SIZE )) && {
    if [[ -n "${EMAIL_TO[*]}" ]]; then
      mailx "${MAILX_ARGS[@]}" -S "from=$EMAIL_FROM" -s "Mirroring report" "${EMAIL_TO[@]}" <<-EOF 2>/dev/null || \
          { printf "%s: %s\\n" "${0##*/}" "mailx command failed" >&2; RET=1; }
		Exit code: $ERR
		Logfile: $LOGSDIR/$LOGFILE.gz
		Output:
		$(< "$LOGSDIR/$LOGFILE")
		EOF
    else
      printf "%s: %s\\n" "${0##*/}" "no recipient configured for mail delivery" >&2
      RET=1
    fi
  }
else
  # Mirroring failed, tell the admin.
  [[ -x /opt/bin/pushover-client ]] && /opt/bin/pushover-client "mirroring" -p -1 -m "Mirroring failure"
  if [[ -n "${EMAIL_TO[*]}" ]]; then
    mailx "${MAILX_ARGS[@]}" -S "from=$EMAIL_FROM" -s "Mirroring failure" "${EMAIL_TO[@]}" <<-EOF 2>/dev/null || \
        { printf "%s: %s\\n" "${0##*/}" "mailx command failed" >&2; RET=1; }
		Exit code: $ERR
		Logfile: $LOGSDIR/$LOGFILE.gz
		Output:
		$(< "$LOGSDIR/$LOGFILE")
		EOF
  else
    printf "%s: %s\\n" "${0##*/}" "no recipient configured for mail delivery" >&2
    RET=1
  fi
fi

# Compress the log to save some space.
gzip -9 "$LOGSDIR/$LOGFILE" 2>/dev/null || { printf "%s: %s '%s'\\n" "${0##*/}" "failed to compress" "$LOGSDIR/$LOGFILE" >&2; RET=1; }

exit "${RET:-0}"
